package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

import java.util.ArrayList;
import java.util.Collections;


public class AddressBook extends AbstractBehavior<AddressBook.Message> {
    ArrayList<ActorRef<Customer.Message>> customers;
    public interface Message {}
    public record CustomerMessage(ActorRef<Customer.Message> fragender, String nameFragender) implements Message{}


    @Override
    public Receive<AddressBook.Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(CustomerMessage.class, this::onCustomerMessage)
                .build();
    }

    public static Behavior<AddressBook.Message> create(ArrayList<ActorRef<Customer.Message>> custo){
        return Behaviors.setup(context -> new AddressBook(context, custo));
    }

    private AddressBook(ActorContext<AddressBook.Message> context, ArrayList<ActorRef<Customer.Message>> actors){
        super(context);
        customers = actors;
    }

    //Methode, um einen zufälligen Empfänger auszugeben
    public Behavior<Message> onCustomerMessage(CustomerMessage msg){
        Collections.shuffle(customers);
        var addressOf = customers.get(0);
        getContext().getLog().info("{} asked for an address",msg.nameFragender);
        msg.fragender.tell(new Customer.AddressMessage(addressOf));
        return this;
    }
}
