package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

import java.util.Random;

public class Customer extends AbstractBehavior<Customer.Message> {

    String name;
    String[] gegenstaende = {"Spülmaschine","Altes CD-Regal", "Goldbarren","20kg Hanteln", "Holzkohlegrill","Blumenerde"};

    public interface Message {}

    //Delivery Nachricht Typ
    public record DeliveryMessage(Paket paket) implements Message {}
   //Pickup Nachricht Typ
    public record PickUpMessage(ActorRef<AkkaMainSystem.Create> truckReference, String someString) implements Message {}

    private Customer(ActorContext<Message> context, String name){
        super(context);
        this.name = name;
    }

    public static Behavior<Customer.Message> create(String name) {
        return Behaviors.setup(context -> new Customer(context, name));
    }

    //Verarbeiten von den DeliveryMessage und PickUpMessage Nachrichten
    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(DeliveryMessage.class, this::onDeliveryMessage)
                .onMessage(PickUpMessage.class, this::onPickUpMessage)
                .build();
    }

    //Verhalten, wenn Pickup Nachricht eingegangen ist
    private Behavior<Message> onPickUpMessage(PickUpMessage msg){
        Random random = new Random();
        int number = random.nextInt(100);
        if(number <= 80){
            //TODO: Nachricht an AddressBook schicken

        }else{
            //TODO: PickupResponse an Wagen schicken
        }
        return this;
    }

    //Verhalten, wenn Paket eingegangen ist
    private Behavior<Message> onDeliveryMessage(DeliveryMessage pkt){
        getContext().getLog().info("Ich habe ein Paket von {} erhalten mit dem Inhalt: {}",pkt.paket.inhalt, pkt.paket.absender);
        return this;
    }
}
